package com.platomix.activity.clickhouse.mapper;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.Update;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.platomix.activity.clickhouse.model.ActivityData;

/**
 * Desc:
 * <p>
 * Modify:
 * <p>
 * Author: William Lynn
 * <p>
 * Create Date：Aug 18, 2021 4:22:19 PM
 * 
 */
@Mapper
public interface ActivityDataMapper extends BaseMapper<ActivityData> {

//	@Select("SELECT ID FROM ads.ACTIVITY_DATA " + " ${ew.customSqlSegment}")
//	public Long getMaxId(@Param(Constants.WRAPPER) QueryWrapper<ActivityData> tagWrapper);
	
	@Update("truncate table ads.ACTIVITY_DATA_MID_JOIN")
	public void truncateJoin();
	
	@Update("truncate table ads.ACTIVITY_DATA_MID_EXCHANGE")
	public void truncateExchange();

	@Update("ALTER TABLE ads.ACTIVITY_DATA_RET DELETE WHERE PARTITION_KEY = ${key}")
	public void deletePartitionByKey(int key);

	@Update("ALTER TABLE ads.ACTIVITY_DATA_RET DELETE " + "WHERE PARTITION_KEY >= ${keyStart} " + "AND "
			+ "PARTITION_KEY <= ${keyEnd}")
	public void deletePartitionByRange(int keyStart, int keyEnd);
	
	@Select("insert into ads.ACTIVITY_DATA_MID_JOIN \r\n"
			+ "	(\r\n"
			+ "		PARTITION_KEY,\r\n"
			+ "		THEDVALUE,\r\n"
			+ "		ACTIVITY_NAME,\r\n"
			+ "		ACTIVITY_UUID,\r\n"
			+ "		ACTIVITY_TYPE,\r\n"
			+ "		ACTIVITY_TYPE_NAME,\r\n"
			+ "		PROVINCE,\r\n"
			+ "		CITY,\r\n"
			+ "		CHANNEL_ID,\r\n"
			+ "		CHANNEL_NAME,\r\n"
			+ "		JOIN_USERS,\r\n"
			+ "		JOIN_USERS_NEW,\r\n"
			+ "		JOIN_USERS_OLD,\r\n"
			+ "		JOIN_USERS_VALID,\r\n"
			+ "		WIN_MAN_TIMES,\r\n"
			+ "		WIN_USERS,\r\n"
			+ "		ORDER_USERS_NEW,\r\n"
			+ "		ORDER_USERS_OLD,\r\n"
			+ "		ORDER_USERS_VALID,\r\n"
			+ "		ORDER_USERS_BY_ACTIVITY,\r\n"
			+ "		ORDER_USERS_CANCEL_ACTIVITY,\r\n"
			+ "		ORDER_USERS_NET_GROWTH_ACTIVITY,\r\n"
			+ "		CONVERSION_RATE\r\n"
			+ "	) \r\n"
			+ "select\r\n"
			+ "	j.PARTITION_KEY as PARTITION_KEY,\r\n"
			+ "	j.DATE_VALUE_${field} as THEDVALUE,\r\n"
			+ "	j.ACTIVITY_NAME as ACTIVITY_NAME,\r\n"
			+ "	j.ACTIVITY_UUID as ACTIVITY_UUID,\r\n"
			+ "	j.ACTIVITY_TYPE as ACTIVITY_TYPE,\r\n"
			+ "	j.ACTIVITY_TYPE_NAME as ACTIVITY_TYPE_NAME,\r\n"
			+ "	j.PROVINCE as PROVINCE,\r\n"
			+ "	j.CITY as CITY,\r\n"
			+ "	j.CHANNEL_ID as CHANNEL_ID,\r\n"
			+ "	j.CHANNEL_NAME as CHANNEL_NAME,\r\n"
			+ "	count(distinct j.PHONE) as JOIN_USERS,\r\n"
			+ "	countif(distinct j.PHONE,j.IS_ORDER_YEAR = 0 and j.IS_ORDER_IN_ACTIVITY = 0) as JOIN_USERS_NEW,\r\n"
			+ "	countIf(distinct j.PHONE,j.IS_ORDER_YEAR = 1 and j.IS_ORDER_IN_ACTIVITY = 0) as JOIN_USERS_OLD,\r\n"
			+ "	countIf(distinct j.PHONE,j.IS_ORDER_IN_ACTIVITY = 1) as JOIN_USERS_VALID,\r\n"
			+ "	countIf(j.JOIN_ID,j.IS_HIT = 1) as WIN_MAN_TIMES,\r\n"
			+ "	countIf(distinct j.PHONE,j.IS_HIT = 1) as WIN_USERS,\r\n"
			+ "	countif(distinct j.PHONE,j.IS_ORDER_BY_ACTIVITY = 1 and j.IS_ORDER_YEAR = 0 and j.IS_ORDER_IN_ACTIVITY = 0) as ORDER_USERS_NEW,\r\n"
			+ "	countIf(distinct j.PHONE,j.IS_ORDER_BY_ACTIVITY = 1 and j.IS_ORDER_YEAR = 1 and j.IS_ORDER_IN_ACTIVITY = 0) as ORDER_USERS_OLD,\r\n"
			+ "	countIf(distinct j.PHONE,j.IS_ORDER_BY_ACTIVITY = 1 and j.IS_ORDER_IN_ACTIVITY = 1) as ORDER_USERS_VALID,\r\n"
			+ "	countIf(distinct j.PHONE,j.IS_ORDER_BY_ACTIVITY = 1) as ORDER_USERS_BY_ACTIVITY,\r\n"
			+ "	0 \"ORDER_USERS_CANCEL_ACTIVITY\",\r\n"
			+ "	0 \"ORDER_USERS_NET_GROWTH_ACTIVITY\",\r\n"
			+ "	0 \"CONVERSION_RATE\"\r\n"
			+ "from\r\n"
			+ "	ads.ACTIVITY_DATA_RECORD_JOIN j\r\n"
			+ "where\r\n"
			+ "	j.DATE_VALUE_${field} >= #{startTime}\r\n"
			+ "	and j.DATE_VALUE_${field} <= #{endTime}\r\n"
			+ "group by\r\n"
			+ "	j.PARTITION_KEY,\r\n"
			+ "	j.DATE_VALUE_${field},\r\n"
			+ "	j.ACTIVITY_NAME,\r\n"
			+ "	j.ACTIVITY_UUID,\r\n"
			+ "	j.ACTIVITY_TYPE,\r\n"
			+ "	j.ACTIVITY_TYPE_NAME,\r\n"
			+ "	j.PROVINCE,\r\n"
			+ "	j.CITY,\r\n"
			+ "	j.CHANNEL_ID,\r\n"
			+ "	j.CHANNEL_NAME")
	public void buildJoinAbout(String field,int startTime,int endTime);
	
	@Select("insert into ads.ACTIVITY_DATA_MID_EXCHANGE \r\n"
			+ "	(\r\n"
			+ "		PARTITION_KEY,\r\n"
			+ "		THEDVALUE,\r\n"
			+ "		ACTIVITY_NAME,\r\n"
			+ "		ACTIVITY_UUID,\r\n"
			+ "		ACTIVITY_TYPE,\r\n"
			+ "		ACTIVITY_TYPE_NAME,\r\n"
			+ "		PROVINCE,\r\n"
			+ "		CITY,\r\n"
			+ "		CASH_PRIZE_MAN_TIMES,\r\n"
			+ "		CASH_PRIZE_USERS_NEW,\r\n"
			+ "		CASH_PRIZE_USERS_OLD,\r\n"
			+ "		CASH_PRIZE_USERS_VALID,\r\n"
			+ "		CASH_PRIZE_RATE\r\n"
			+ "	) \r\n"
			+ "select\r\n"
			+ "	e.PARTITION_KEY as PARTITION_KEY,\r\n"
			+ "	e.DATE_VALUE_${field} as THEDVALUE,\r\n"
			+ "	e.ACTIVITY_NAME as ACTIVITY_NAME,\r\n"
			+ "	e.ACTIVITY_UUID as ACTIVITY_UUID,\r\n"
			+ "	e.ACTIVITY_TYPE as ACTIVITY_TYPE,\r\n"
			+ "	e.ACTIVITY_TYPE_NAME as ACTIVITY_TYPE_NAME,\r\n"
			+ "	e.PROVINCE as PROVINCE,\r\n"
			+ "	e.CITY as CITY,\r\n"
			+ "	count() as CASH_PRIZE_MAN_TIMES,\r\n"
			+ "	countIf(distinct e.PHONE,e.IS_ORDER_YEAR = 0 and e.IS_ORDER_IN_ACTIVITY = 0) as CASH_PRIZE_USERS_NEW,\r\n"
			+ "	countIf(distinct e.PHONE,e.IS_ORDER_YEAR = 1 and e.IS_ORDER_IN_ACTIVITY = 0) as CASH_PRIZE_USERS_OLD,\r\n"
			+ "	countIf(distinct e.PHONE,e.IS_ORDER_IN_ACTIVITY = 1) as CASH_PRIZE_USERS_VALID,\r\n"
			+ "	0 \"CASH_PRIZE_RATE\"\r\n"
			+ "from\r\n"
			+ "	ads.ACTIVITY_DATA_RECORD_EXCHANGE e\r\n"
			+ "left join (select distinct ACTIVITY_UUID,PROVINCE,CITY,DATE_VALUE_${field},PHONE,IS_HIT from ads.ACTIVITY_DATA_RECORD_JOIN) j\r\n"
			+ "	on e.ACTIVITY_UUID = j.ACTIVITY_UUID\r\n"
			+ "	and e.PROVINCE = j.PROVINCE\r\n"
			+ "	and e.CITY = j.CITY\r\n"
			+ "	and e.DATE_VALUE_${field} = j.DATE_VALUE_${field} \r\n"
			+ "where\r\n"
			+ "	e.DATE_VALUE_${field} >= #{startTime}\r\n"
			+ "	and e.DATE_VALUE_${field} <= #{endTime}\r\n"
			+ "	and e.EXCHANGE_STATUS = 1\r\n"
			+ "group by\r\n"
			+ "	e.PARTITION_KEY,\r\n"
			+ "	e.DATE_VALUE_${field},\r\n"
			+ "	e.ACTIVITY_NAME,\r\n"
			+ "	e.ACTIVITY_UUID,\r\n"
			+ "	e.ACTIVITY_TYPE,\r\n"
			+ "	e.ACTIVITY_TYPE_NAME,\r\n"
			+ "	e.PROVINCE,\r\n"
			+ "	e.CITY")
	public void buildExchangeAbout(String field,int startTime,int endTime);
	
	@Select("insert into ads.ACTIVITY_DATA_RET \r\n"
			+ " (\r\n"
			+ " PARTITION_KEY,\r\n"
			+ "	DTYPE,\r\n"
			+ "	THEDVALUE,\r\n"
			+ "	ACTIVITY_NAME,\r\n"
			+ "	ACTIVITY_UUID,\r\n"
			+ "	ACTIVITY_TYPE,\r\n"
			+ "	ACTIVITY_TYPE_NAME,\r\n"
			+ "	PROVINCE,\r\n"
			+ "	CITY,\r\n"
			+ "	CHANNEL_ID,\r\n"
			+ "	CHANNEL_NAME,\r\n"
			+ "	JOIN_USERS,\r\n"
			+ "	JOIN_USERS_NEW,\r\n"
			+ "	JOIN_USERS_OLD,\r\n"
			+ "	JOIN_USERS_VALID,\r\n"
			+ "	WIN_MAN_TIMES,\r\n"
			+ "	WIN_USERS,\r\n"
			+ "	ORDER_USERS_NEW,\r\n"
			+ "	ORDER_USERS_OLD,\r\n"
			+ "	ORDER_USERS_VALID,\r\n"
			+ "	ORDER_USERS_BY_ACTIVITY,\r\n"
			+ "	ORDER_USERS_CANCEL_ACTIVITY,\r\n"
			+ "	ORDER_USERS_NET_GROWTH_ACTIVITY,\r\n"
			+ "	CONVERSION_RATE,\r\n"
			+ "	CASH_PRIZE_MAN_TIMES,\r\n"
			+ "	CASH_PRIZE_USERS_NEW,\r\n"
			+ "	CASH_PRIZE_USERS_OLD,\r\n"
			+ "	CASH_PRIZE_USERS_VALID,\r\n"
			+ "	CASH_PRIZE_RATE\r\n"
			+ " ) \r\n"
			+ "with toString(THEDVALUE) as THEDVALUES\r\n"
			+ "select\r\n"
			+ "	PARTITION_KEY,\r\n"
			+ "	(case\r\n"
			+ "		when length(THEDVALUES) = 6 then 'MONTH'\r\n"
			+ "		when length(THEDVALUES) = 8 then 'DAY'\r\n"
			+ "		else 'HOUR'\r\n"
			+ "	end) as DTYPE,\r\n"
			+ "	THEDVALUE,\r\n"
			+ "	ACTIVITY_NAME,\r\n"
			+ "	ACTIVITY_UUID,\r\n"
			+ "	ACTIVITY_TYPE,\r\n"
			+ "	ACTIVITY_TYPE_NAME,\r\n"
			+ "	PROVINCE,\r\n"
			+ "	CITY,\r\n"
			+ "	CHANNEL_ID,\r\n"
			+ "	CHANNEL_NAME,\r\n"
			+ "	sum(JOIN_USERS),\r\n"
			+ "	sum(JOIN_USERS_NEW),\r\n"
			+ "	sum(JOIN_USERS_OLD),\r\n"
			+ "	sum(JOIN_USERS_VALID),\r\n"
			+ "	sum(WIN_MAN_TIMES),\r\n"
			+ "	sum(WIN_USERS),\r\n"
			+ "	sum(ORDER_USERS_NEW),\r\n"
			+ "	sum(ORDER_USERS_OLD),\r\n"
			+ "	sum(ORDER_USERS_VALID),\r\n"
			+ "	sum(ORDER_USERS_BY_ACTIVITY),\r\n"
			+ "	sum(ORDER_USERS_CANCEL_ACTIVITY),\r\n"
			+ "	sum(ORDER_USERS_NET_GROWTH_ACTIVITY),\r\n"
			+ "	(case \r\n"
			+ "		when length(THEDVALUES) = 6 then cast(if(sum(JOIN_USERS)=0,0,divide(sum(ORDER_USERS_BY_ACTIVITY),sum(JOIN_USERS))),'Decimal(9,4)')\r\n"
			+ "		else cast(0,'Decimal(9,4)')\r\n"
			+ "	end) as CONVERSION_RATE,\r\n"
			+ "	sum(CASH_PRIZE_MAN_TIMES),\r\n"
			+ "	sum(CASH_PRIZE_USERS_NEW),\r\n"
			+ "	sum(CASH_PRIZE_USERS_OLD),\r\n"
			+ "	sum(CASH_PRIZE_USERS_VALID),\r\n"
			+ "	(case \r\n"
			+ "		when length(THEDVALUES) = 6 then cast(if(sum(WIN_MAN_TIMES)=0,0,divide(sum(CASH_PRIZE_MAN_TIMES),sum(WIN_MAN_TIMES))),'Decimal(9,4)')\r\n"
			+ "		else cast(0,'Decimal(9,4)')\r\n"
			+ "	end) as CASH_PRIZE_RATE\r\n"
			+ "from\r\n"
			+ "	(\r\n"
			+ "	select\r\n"
			+ "		PARTITION_KEY,\r\n"
			+ "		THEDVALUE,\r\n"
			+ "		ACTIVITY_NAME,\r\n"
			+ "		ACTIVITY_UUID,\r\n"
			+ "		ACTIVITY_TYPE,\r\n"
			+ "		ACTIVITY_TYPE_NAME,\r\n"
			+ "		PROVINCE,\r\n"
			+ "		CITY,\r\n"
			+ "		CHANNEL_ID,\r\n"
			+ "		CHANNEL_NAME,\r\n"
			+ "		JOIN_USERS,\r\n"
			+ "		JOIN_USERS_NEW,\r\n"
			+ "		JOIN_USERS_OLD,\r\n"
			+ "		JOIN_USERS_VALID,\r\n"
			+ "		WIN_MAN_TIMES,\r\n"
			+ "		WIN_USERS,\r\n"
			+ "		ORDER_USERS_NEW,\r\n"
			+ "		ORDER_USERS_OLD,\r\n"
			+ "		ORDER_USERS_VALID,\r\n"
			+ "		ORDER_USERS_BY_ACTIVITY,\r\n"
			+ "		ORDER_USERS_CANCEL_ACTIVITY,\r\n"
			+ "		ORDER_USERS_NET_GROWTH_ACTIVITY,\r\n"
			+ "		CONVERSION_RATE,\r\n"
			+ "		0 \"CASH_PRIZE_MAN_TIMES\",\r\n"
			+ "		0 \"CASH_PRIZE_USERS_NEW\",\r\n"
			+ "		0 \"CASH_PRIZE_USERS_OLD\",\r\n"
			+ "		0 \"CASH_PRIZE_USERS_VALID\",\r\n"
			+ "		0 \"CASH_PRIZE_RATE\"\r\n"
			+ "	from\r\n"
			+ "		ads.ACTIVITY_DATA_MID_JOIN\r\n"
			+ "union all\r\n"
			+ "	select\r\n"
			+ "		PARTITION_KEY,\r\n"
			+ "		THEDVALUE,\r\n"
			+ "		ACTIVITY_NAME,\r\n"
			+ "		ACTIVITY_UUID,\r\n"
			+ "		ACTIVITY_TYPE,\r\n"
			+ "		ACTIVITY_TYPE_NAME,\r\n"
			+ "		PROVINCE,\r\n"
			+ "		CITY,\r\n"
			+ "		'166887' \"CHANNEL_ID\",\r\n"
			+ "		'畅视公众号' \"CHANNEL_NAME\",\r\n"
			+ "		0 \"JOIN_USERS\",\r\n"
			+ "		0 \"JOIN_USERS_NEW\",\r\n"
			+ "		0 \"JOIN_USERS_OLD\",\r\n"
			+ "		0 \"JOIN_USERS_VALID\",\r\n"
			+ "		0 \"WIN_MAN_TIMES\",\r\n"
			+ "		0 \"WIN_USERS\",\r\n"
			+ "		0 \"ORDER_USERS_NEW\",\r\n"
			+ "		0 \"ORDER_USERS_OLD\",\r\n"
			+ "		0 \"ORDER_USERS_VALID\",\r\n"
			+ "		0 \"ORDER_USERS_BY_ACTIVITY\",\r\n"
			+ "		0 \"ORDER_USERS_CANCEL_ACTIVITY\",\r\n"
			+ "		0 \"ORDER_USERS_NET_GROWTH_ACTIVITY\",\r\n"
			+ "		0 \"CONVERSION_RATE\",\r\n"
			+ "		CASH_PRIZE_MAN_TIMES,\r\n"
			+ "		CASH_PRIZE_USERS_NEW,\r\n"
			+ "		CASH_PRIZE_USERS_OLD,\r\n"
			+ "		CASH_PRIZE_USERS_VALID,\r\n"
			+ "		0 \"CASH_PRIZE_RATE\"\r\n"
			+ "	from\r\n"
			+ "		ads.ACTIVITY_DATA_MID_EXCHANGE\r\n"
			+ " )\r\n"
			+ "group by\r\n"
			+ "	PARTITION_KEY,\r\n"
			+ "	THEDVALUE,\r\n"
			+ "	ACTIVITY_NAME,\r\n"
			+ "	ACTIVITY_UUID,\r\n"
			+ "	ACTIVITY_TYPE,\r\n"
			+ "	ACTIVITY_TYPE_NAME,\r\n"
			+ "	PROVINCE,\r\n"
			+ "	CITY,\r\n"
			+ "	CHANNEL_ID,\r\n"
			+ "	CHANNEL_NAME")
	public void merge();
}
