package com.platomix.activity.clickhouse.mapper;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.platomix.activity.clickhouse.model.ActivityMemberExchangeRecord;

/**
 * 
 * Desc: 活动会员兑奖记录表 Mapper 接口
 * <p>
 * Modify:
 * <p>
 * Author: William Lynn
 * <p>
 * Create Date：Sep 2, 2021 4:52:03 PM
 *
 */
@Mapper
public interface ActivityMemberExchangeRecordMapper extends BaseMapper<ActivityMemberExchangeRecord> {
	@Select("insert into ads.ACTIVITY_DATA_RECORD_EXCHANGE\r\n"
			+ "(\r\n"
			+ "	PARTITION_KEY,\r\n"
			+ "	EXCHANGE_ID,\r\n"
			+ "	ACTIVITY_UUID,\r\n"
			+ "	ACTIVITY_NAME,\r\n"
			+ "	ACTIVITY_TYPE,\r\n"
			+ "	ACTIVITY_TYPE_NAME,\r\n"
			+ "	PRIZE_ID,\r\n"
			+ "	PRIZE_NAME,\r\n"
			+ "	PRIZE_TYPE,\r\n"
			+ "	PRIZE_LEVEL,\r\n"
			+ "	WIN_CODE,\r\n"
			+ "	PROVINCE,\r\n"
			+ "	CITY,\r\n"
			+ "	PHONE,\r\n"
			+ "	EXCHANGE_TIME,\r\n"
			+ "	EXCHANGE_STATUS,\r\n"
			+ "	EXCHANGE_STATUS_NAME,\r\n"
			+ "	DATE_VALUE_MONTH,\r\n"
			+ "	DATE_VALUE_DAY,\r\n"
			+ "	DATE_VALUE_HOUR,\r\n"
			+ "	IS_ORDER_YEAR,\r\n"
			+ "	IS_ORDER_IN_ACTIVITY\r\n"
			+ ")\r\n"
			+ "select\r\n"
			+ "toInt32(toYYYYMM(toTimeZone(p.exchange_time, 'Asia/Shanghai'))) as PARTITION_KEY,\r\n"
			+ "p.id as EXCHANGE_ID,\r\n"
			+ "p.activity_uuid as ACTIVITY_UUID,\r\n"
			+ "p.activity_name as ACTIVITY_NAME,\r\n"
			+ "p.activity_type as ACTIVITY_TYPE,\r\n"
			+ "(case \r\n"
			+ "	when p.activity_type = 1 then '活动类'\r\n"
			+ "	when p.activity_type = 2 then '订购类'\r\n"
			+ "	when p.activity_type = 3 then '游戏类'\r\n"
			+ "	when p.activity_type = 4 then '秒杀类'\r\n"
			+ "	when p.activity_type = 5 then '助力类'\r\n"
			+ "	else '抽奖类'\r\n"
			+ "end) as ACTIVITY_TYPE_NAME,\r\n"
			+ "prize_id as PRIZE_ID,\r\n"
			+ "prize_name as PRIZE_NAME,\r\n"
			+ "prize_type as PRIZE_TYPE,\r\n"
			+ "if(isNull(prize_level)=1,'',prize_level) as PRIZE_LEVEL,\r\n"
			+ "if(isNull(win_code)=1,'',win_code) as WIN_CODE,\r\n"
			+ "caller.PROVINCE as PROVINCE,\r\n"
			+ "caller.AREA as CITY,\r\n"
			+ "p.member_phone as PHONE,\r\n"
			+ "p.exchange_time as EXCHANGE_TIME,\r\n"
			+ "p.exchange_status as EXCHANGE_STATUS,\r\n"
			+ "if(p.exchange_status = 1,'已兑奖','未兑奖') as EXCHANGE_STATUS_NAME,\r\n"
			+ "toInt32(toYYYYMM(toTimeZone(p.exchange_time, 'Asia/Shanghai'))) as DATE_VALUE_MONTH,\r\n"
			+ "toInt32(toYYYYMMDD(toTimeZone(p.exchange_time, 'Asia/Shanghai'))) as DATE_VALUE_DAY,\r\n"
			+ "toInt32(substring(toString(toYYYYMMDDhhmmss(toTimeZone(p.exchange_time, 'Asia/Shanghai'))),1,10)) as DATE_VALUE_HOUR,\r\n"
			+ "if(\r\n"
			+ "	o.ORDER_TIME >= subtractMonths(act.START_TIME ,12)\r\n"
			+ "	and o.ORDER_TIME < act.START_TIME\r\n"
			+ "	and o.USERID is not null\r\n"
			+ "	and o.USERID != '',\r\n"
			+ "	1,0\r\n"
			+ ") as IS_ORDER_YEAR,\r\n"
			+ "if(\r\n"
			+ "	o.USERID is not null\r\n"
			+ "	and o.USERID != ''\r\n"
			+ "	and (\r\n"
			+ "		(\r\n"
			+ "			o.ORDER_TIME < act.START_TIME\r\n"
			+ "			and (\r\n"
			+ "				(o.CANCEL_TIME = toDate('1970-01-01') and o.END_TIME = toDate('1970-01-01'))\r\n"
			+ "				or\r\n"
			+ "				greatest(o.CANCEL_TIME,o.END_TIME) >= act.START_TIME\r\n"
			+ "			)\r\n"
			+ "		)\r\n"
			+ "	),\r\n"
			+ "	1,0\r\n"
			+ ") as IS_ORDER_IN_ACTIVITY\r\n"
			+ "from ads.BLADE_ACTIVITY_MEMBER_EXCHANGE_RECORD p\r\n"
			+ "left join ads.ETL_VW_TB_CALLER_AREACODE caller\r\n"
			+ "	on substring(p.member_phone,1,7) = caller.CALLERHEAD\r\n"
			+ "inner join ads.ACTIVITY_DATA_BASE_INFO act \r\n"
			+ "	on act.ACTIVITY_UUID  = p.activity_uuid\r\n"
			+ "left join (\r\n"
			+ "			select\r\n"
			+ "			max(THEMONTH) as THE_MONTH,\r\n"
			+ "			USERID,\r\n"
			+ "			PROVINCE,\r\n"
			+ "			AREA,\r\n"
			+ "			max(ORDERTIME) as ORDER_TIME, \r\n"
			+ "			max(CANCELTIME) as CANCEL_TIME,\r\n"
			+ "			max(ENDTIME) as END_TIME\r\n"
			+ "			from ads.HIS_FLOW_ORDER \r\n"
			+ "			where ORDERTIME > subtractMonths(now(),24) \r\n"
			+ "			group by USERID,PROVINCE,AREA\r\n"
			+ "		) o\r\n"
			+ "	on p.member_phone = o.USERID\r\n"
			+ "	and PROVINCE = o.PROVINCE\r\n"
			+ "	and CITY = o.AREA\r\n"
			+ "where \r\n"
			+ "	p.id > #{id}\r\n"
			+ "	and p.member_phone is not null \r\n"
			+ "	and length(p.member_phone) = 11\r\n"
			+ "	and p.exchange_time >= act.START_TIME\r\n"
			+ "	and act.CASH_DEADLINE is not null \r\n"
			+ "	and p.exchange_time <= act.CASH_DEADLINE\r\n"
			+ "	and PROVINCE is not null\r\n"
			+ "	and CITY is not null")
	public void clean(long id);
}
