package com.platomix.activity.clickhouse.mapper;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.platomix.activity.clickhouse.model.ActivityParticipateRecord;

/**
 * 
 * Desc: 活动参与记录表 Mapper 接口
 * <p>
 * Modify:
 * <p>
 * Author: William Lynn
 * <p>
 * Create Date：Sep 2, 2021 4:51:41 PM
 *
 */
@Mapper
public interface ActivityParticipateRecordMapper extends BaseMapper<ActivityParticipateRecord> {
	@Select("insert into ads.ACTIVITY_DATA_RECORD_JOIN\r\n"
			+ "(\r\n"
			+ "	PARTITION_KEY,\r\n"
			+ "	JOIN_ID,\r\n"
			+ "	ACTIVITY_UUID,\r\n"
			+ "	ACTIVITY_NAME,\r\n"
			+ "	ACTIVITY_TYPE,\r\n"
			+ "	ACTIVITY_TYPE_NAME,\r\n"
			+ "	CHANNEL_ID,\r\n"
			+ "	CHANNEL_NAME,\r\n"
			+ "	PROVINCE,\r\n"
			+ "	CITY,\r\n"
			+ "	PHONE,\r\n"
			+ "	IP,\r\n"
			+ "	IS_HIT,\r\n"
			+ "	JOIN_TIME,\r\n"
			+ "	DATE_VALUE_MONTH,\r\n"
			+ "	DATE_VALUE_DAY,\r\n"
			+ "	DATE_VALUE_HOUR,\r\n"
			+ "	IS_ORDER_YEAR,\r\n"
			+ "	IS_ORDER_IN_ACTIVITY,\r\n"
			+ "	IS_ORDER_BY_ACTIVITY\r\n"
			+ ")\r\n"
			+ "select\r\n"
			+ "toInt32(toYYYYMM(toTimeZone(p.participate_time, 'Asia/Shanghai'))) as PARTITION_KEY,\r\n"
			+ "p.id as JOIN_ID,\r\n"
			+ "p.activity_uuid as ACTIVITY_UUID,\r\n"
			+ "p.activity_name as ACTIVITY_NAME,\r\n"
			+ "p.activity_type as ACTIVITY_TYPE,\r\n"
			+ "(case \r\n"
			+ "	when p.activity_type = 1 then '活动类'\r\n"
			+ "	when p.activity_type = 2 then '订购类'\r\n"
			+ "	when p.activity_type = 3 then '游戏类'\r\n"
			+ "	when p.activity_type = 4 then '秒杀类'\r\n"
			+ "	when p.activity_type = 5 then '助力类'\r\n"
			+ "	else '抽奖类'\r\n"
			+ "end) as ACTIVITY_TYPE_NAME,\r\n"
			+ "(case \r\n"
			+ "	when length(p.participate_channel)=0 or isNull(p.participate_channel)=1 then '166887'\r\n"
			+ "	else p.participate_channel\r\n"
			+ "end) as \"CHANNEL_ID\",\r\n"
			+ "(case \r\n"
			+ "	when length(p.participate_channel)=0 or isNull(p.participate_channel)=1 then '畅视公众号'\r\n"
			+ "	else ch.name\r\n"
			+ "end) as CHANNEL_NAME,\r\n"
			+ "caller.PROVINCE as PROVINCE,\r\n"
			+ "caller.AREA as CITY,\r\n"
			+ "p.participate_phone as PHONE,\r\n"
			+ "p.ip_address as IP,\r\n"
			+ "if(p.is_hit = 1,1,0) as IS_HIT,\r\n"
			+ "p.participate_time as JOIN_TIME,\r\n"
			+ "toInt32(toYYYYMM(toTimeZone(p.participate_time, 'Asia/Shanghai'))) as DATE_VALUE_MONTH,\r\n"
			+ "toInt32(toYYYYMMDD(toTimeZone(p.participate_time, 'Asia/Shanghai'))) as DATE_VALUE_DAY,\r\n"
			+ "toInt32(substring(toString(toYYYYMMDDhhmmss(toTimeZone(p.participate_time, 'Asia/Shanghai'))),1,10)) as DATE_VALUE_HOUR,\r\n"
			+ "if(\r\n"
			+ "	o.ORDER_TIME >= subtractMonths(act.START_TIME ,12)\r\n"
			+ "	and o.ORDER_TIME < act.START_TIME\r\n"
			+ "	and o.USERID is not null\r\n"
			+ "	and o.USERID != '',\r\n"
			+ "	1,0\r\n"
			+ ") as IS_ORDER_YEAR,\r\n"
			+ "if(\r\n"
			+ "	o.USERID is not null\r\n"
			+ "	and o.USERID != ''\r\n"
			+ "	and (\r\n"
			+ "		(\r\n"
			+ "			--o.THE_MONTH = toYYYYMM(toTimeZone(act.START_TIME, 'Asia/Shanghai'))\r\n"
			+ "			o.ORDER_TIME < act.START_TIME\r\n"
			+ "			and (\r\n"
			+ "				(o.CANCEL_TIME = toDate('1970-01-01') and o.END_TIME = toDate('1970-01-01'))\r\n"
			+ "				or\r\n"
			+ "				greatest(o.CANCEL_TIME,o.END_TIME) >= act.START_TIME\r\n"
			+ "			)\r\n"
			+ "		)\r\n"
			+ "	),\r\n"
			+ "	1,0\r\n"
			+ ") as IS_ORDER_IN_ACTIVITY,\r\n"
			+ "if(\r\n"
			+ "	o.USERID is not null\r\n"
			+ "	and o.USERID != ''\r\n"
			+ "	and length(arrayIntersect(act.SPIDS,o.SPIDS))>0\r\n"
			+ "	and o.ORDER_TIME >= act.START_TIME\r\n"
			+ "	and o.ORDER_TIME <= act.END_TIME\r\n"
			+ ",1,0) as IS_ORDER_BY_ACTIVITY\r\n"
			+ "from ads.BLADE_ACTIVITY_PARTICIPATE_RECORD p\r\n"
			+ "left join ads.DIC_BLADE_ACTIVITY_CHANNEL ch\r\n"
			+ "	on p.participate_channel = ch.channel_id \r\n"
			+ "left join ads.ETL_VW_TB_CALLER_AREACODE caller\r\n"
			+ "	on substring(p.participate_phone,1,7) = caller.CALLERHEAD\r\n"
			+ "inner join ads.ACTIVITY_DATA_BASE_INFO act \r\n"
			+ "	on act.ACTIVITY_UUID  = p.activity_uuid\r\n"
			+ "left join (\r\n"
			+ "			select\r\n"
			+ "			max(THEMONTH) as THE_MONTH,\r\n"
			+ "			groupArray(SPID) as SPIDS,\r\n"
			+ "			USERID,\r\n"
			+ "			PROVINCE,\r\n"
			+ "			AREA,\r\n"
			+ "			max(ORDERTIME) as ORDER_TIME, \r\n"
			+ "			max(CANCELTIME) as CANCEL_TIME,\r\n"
			+ "			max(ENDTIME) as END_TIME\r\n"
			+ "			from ads.HIS_FLOW_ORDER \r\n"
			+ "			where ORDERTIME > subtractMonths(now(),24) \r\n"
			+ "			group by USERID,PROVINCE,AREA\r\n"
			+ "		) o\r\n"
			+ "	on p.participate_phone = o.USERID\r\n"
			+ "	and PROVINCE = o.PROVINCE\r\n"
			+ "	and CITY = o.AREA\r\n"
			+ "where \r\n"
			+ "	p.id > #{id}\r\n"
			+ "	and p.participate_phone is not null \r\n"
			+ "	and length(p.participate_phone) = 11\r\n"
			+ "	and p.participate_time >= act.START_TIME \r\n"
			+ "	and p.participate_time <= act.END_TIME\r\n"
			+ "	and PROVINCE is not null\r\n"
			+ "	and CITY is not null")
	public void clean(long id);
}
