package com.platomix.activity.clickhouse.model;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.platomix.activity.enums.DateTypeEnum;

import lombok.Data;

/**
 * Desc:结果表
 * <p>
 * Modify:
 * <p>
 * Author: William Lynn
 * <p>
 * Create Date：Aug 18, 2021 10:20:29 AM
 * 
 */
@Data
@TableName("ACTIVITY_DATA_RET")
public class ActivityData implements Serializable {
	private static final long serialVersionUID = 1L;

	@TableField(value = "PARTITION_KEY")
	private Integer partitionKey;

	@TableField(value = "DTYPE")
	private String dType;

	@TableField(value = "THEDVALUE")
	private Integer theDValue;

//	@TableField(value = "ACTIVITY_ID")
//	private Long activityId;

	@TableField(value = "ACTIVITY_UUID")
	private String activityUuid;

	@TableField(value = "ACTIVITY_TYPE")
	private Integer activityType;

	@TableField(value = "ACTIVITY_TYPE_NAME")
	private String activityTypeName;

	@TableField(value = "ACTIVITY_NAME")
	private String activityName;

//	@JsonFormat(pattern = "yyyy-MM-dd")
//	@TableField(value = "START_TIME")
//	private Date startTime;
//
//	@JsonFormat(pattern = "yyyy-MM-dd")
//	@TableField(value = "END_TIME")
//	private Date endTime;
//
//	@JsonFormat(pattern = "yyyy-MM-dd")
//	@TableField(value = "CASH_DEADLINE")
//	private Date cashDeadline;
//
//	@TableField(value = "STATUS")
//	private Integer status;
//
//	@TableField(value = "STATUS_NAME")
//	private String statusName;
//
//	@TableField(value = "IS_THIRD")
//	private Integer isThird;
//
//	@TableField(value = "IS_THIRD_NAME")
//	private String isThirdName;

	@TableField(value = "PROVINCE")
	private String province;

	@TableField(value = "CITY")
	private String city;

	// 渠道ID，即是渠道推广ID
	@TableField(value = "CHANNEL_ID")
	private String channelId;

	@TableField(value = "CHANNEL_NAME")
	private String channelName;

//	@TableField(value = "CHANNEL_ID_ORDER")
//	private String channelIdOrder;
//
//	@TableField(value = "CHANNEL_TYPE")
//	private String channelType;

//	@TableField(value = "MANAGER")
//	private String manager;
//
//	@TableField(value = "MANAGER_DEPT")
//	private String managerDept;
//
//	@TableField(value = "MANAGER_JOB")
//	private String managerJob;
//
//	@TableField(value = "MANAGER_PHONE")
//	private String managerPhone;
//
//	@TableField(value = "MANAGER_EMAIL")
//	private String managerEmail;
//
//	@TableField(value = "PRIZE_ID")
//	private String prizeId;
//
//	@TableField(value = "PRIZE_NAME")
//	private String prizeName;
//
//	@TableField(value = "PRIZE_TYPE")
//	private Integer prizeType;
//
//	@TableField(value = "PRIZE_LEVEL")
//	private Integer prizeLevel;

//	@TableField(value = "PRODUCT_NAME")
//	private String productName;
//
//	@TableField(value = "SPID")
//	private String spid;
//
//	@TableField(value = "CPID")
//	private String cpid;
//
//	@TableField(value = "PRODUCT_LARGE_TYPE")
//	private String productLargeType;
//
//	@TableField(value = "PRODUCT_SMALL_TYPE")
//	private String productSmallType;

//	@TableField(value = "PV_FIRST")
//	private Long pvFirst;
//
//	@TableField(value = "PV_SECOND")
//	private Long pvSecond;
//
//	@TableField(value = "PV_THIRD")
//	private Long pvThird;
//
//	@TableField(value = "PV_FORTH")
//	private Long pvForth;
//
//	@TableField(value = "UV_FIRST")
//	private Long uvFirst;
//
//	@TableField(value = "UV_SECOND")
//	private Long uvSecond;
//
//	@TableField(value = "UV_THIRD")
//	private Long uvThird;
//
//	@TableField(value = "UV_FORTH")
//	private Long uvForth;
	
	@TableField(value = "JOIN_USERS")
	private Long joinUsers;

	@TableField(value = "JOIN_USERS_NEW")
	private Long joinUsersNew;

	@TableField(value = "JOIN_USERS_OLD")
	private Long joinUsersOld;

	@TableField(value = "JOIN_USERS_VALID")
	private Long joinUsersValid;

	@TableField(value = "WIN_MAN_TIMES")
	private Long winManTimes;

	@TableField(value = "WIN_USERS")
	private Long winUsers;

	@TableField(value = "CASH_PRIZE_MAN_TIMES")
	private Long cashPrizeManTimes;

	@TableField(value = "CASH_PRIZE_USERS_NEW")
	private Long cashPrizeUsersNew;

	@TableField(value = "CASH_PRIZE_USERS_OLD")
	private Long cashPrizeUsersOld;

	@TableField(value = "CASH_PRIZE_USERS_VALID")
	private Long cashPrizeUsersValid;

	@TableField(value = "CASH_PRIZE_RATE")
	private BigDecimal cashPrizeRate;

	@TableField(value = "ORDER_USERS_NEW")
	private Long orderUsersNew;

	@TableField(value = "ORDER_USERS_OLD")
	private Long orderUsersOld;

	@TableField(value = "ORDER_USERS_VALID")
	private Long orderUsersValid;

	@TableField(value = "ORDER_USERS_BY_ACTIVITY")
	private BigDecimal orderUsersByActivity;

	@TableField(value = "ORDER_USERS_CANCEL_ACTIVITY")
	private Long orderUsersCancelActivity;

	@TableField(value = "ORDER_USERS_NET_GROWTH_ACTIVITY")
	private Long orderUsersNetGrowthActivity;

	@TableField(value = "CONVERSION_RATE")
	private BigDecimal conversionRate;

	@TableField(value = "ACTIVE_USERS_RATE")
	private BigDecimal activeUsersRate;
	
	@TableField(value = "COMPLAINT_USERS")
	private BigDecimal complaintUsers;

	@TableField(value = "CREATE_TIME")
	private Date createTime;

	public String getDType() {
		int len = String.valueOf(theDValue).length();
		if (len == 6) {
			return DateTypeEnum.MONTH.name();
		} else if (len == 8) {
			return DateTypeEnum.DAY.name();
		} else {
			return DateTypeEnum.HOUR.name();
		}
	}
}
