package com.platomix.activity.clickhouse.model;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

import org.apache.ibatis.type.JdbcType;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.platomix.activity.common.ArrayTypeHandler;

import lombok.Data;

/**
 * Desc:活动基础信息表
 * <p>
 * Modify:
 * <p>
 * Author: William Lynn
 * <p>
 * Create Date：Aug 18, 2021 10:20:29 AM
 * 
 */
@Data
@TableName("ACTIVITY_DATA_BASE_INFO")
public class ActivityDataBaseInfo implements Serializable {
	private static final long serialVersionUID = 1L;

	@TableId(value = "ID", type = IdType.ASSIGN_ID)
	private Long id;

	@TableField(value = "ACTIVITY_ID")
	private Long activityId;

	@TableField(value = "ACTIVITY_UUID")
	private String activityUuid;

	@TableField(value = "ACTIVITY_NAME")
	private String activityName;

	@TableField(value = "ACTIVITY_TYPE")
	private Integer activityType;

	@TableField(value = "ACTIVITY_TYPE_NAME")
	private String activityTypeName;

	@TableField(value = "IS_THIRD")
	private Integer isThird;

	@TableField(value = "IS_THIRD_NAME")
	private String isThirdName;

	@TableField(value = "SPIDS", typeHandler = ArrayTypeHandler.class, jdbcType = JdbcType.ARRAY)
	private String[] spids;

	@TableField(value = "STATUS")
	private Integer status;

	@TableField(value = "STATUS_NAME")
	private String statusName;

	@TableField(value = "START_TIME")
	private Date startTime;

	@TableField(value = "END_TIME")
	private Date endTime;

	@TableField(value = "CASH_DEADLINE")
	private Date cashDeadline;

	@TableField(value = "DEADLINE")
	private Date deadline;

	@TableField(value = "COST_TOTAL_ACTIVITY")
	private BigDecimal costTotalActivity;

	@TableField(value = "COST_TOTAL_PRIZE")
	private BigDecimal costTotalPrize;

	@TableField(value = "COST_TOTAL_CHANNEL")
	private BigDecimal costTotalChannel;

	@TableField(value = "COST_TOTAL_PRODUCT")
	private BigDecimal costTotalProduct;

	@TableField(value = "COST_TOTAL_OTHER")
	private BigDecimal costTotalOther;

//	@TableField(value = "INCOME_TOTAL_ACTIVITY")
//	private BigDecimal incomeTotalActivity;

	@TableField(value = "CREATE_TIME")
	private Date createTime;
}
