package com.platomix.activity.clickhouse.model;

import java.io.Serializable;

import com.baomidou.mybatisplus.annotation.TableField;
import com.platomix.activity.enums.DateTypeEnum;

/**
 * Desc:中间表父类
 * <p>
 * Modify:
 * <p>
 * Author: William Lynn
 * <p>
 * Create Date：Aug 18, 2021 10:20:29 AM
 * 
 */
public class ActivityDataMid implements Serializable {
	private static final long serialVersionUID = 1L;
	
	@TableField(value = "PARTITION_KEY")
	private Integer partitionKey;

	@TableField(value = "THEDVALUE")
	private Integer theDValue;

	@TableField(value = "ACTIVITY_UUID")
	private String activityUuid;

	@TableField(value = "ACTIVITY_TYPE")
	private Integer activityType;

	@TableField(value = "ACTIVITY_TYPE_NAME")
	private String activityTypeName;

	@TableField(value = "ACTIVITY_NAME")
	private String activityName;

	@TableField(value = "PROVINCE")
	private String province;

	@TableField(value = "CITY")
	private String city;

	public String getdType() {
		int len = String.valueOf(theDValue).length();
		if (len == 6) {
			return DateTypeEnum.MONTH.name();
		} else if (len == 8) {
			return DateTypeEnum.DAY.name();
		} else {
			return DateTypeEnum.HOUR.name();
		}
	}

	public Integer getTheDValue() {
		return theDValue;
	}

	public void setTheDValue(Integer theDValue) {
		this.theDValue = theDValue;
	}

	public String getActivityUuid() {
		return activityUuid;
	}

	public void setActivityUuid(String activityUuid) {
		this.activityUuid = activityUuid;
	}

	public Integer getActivityType() {
		return activityType;
	}

	public void setActivityType(Integer activityType) {
		this.activityType = activityType;
	}

	public String getActivityTypeName() {
		return activityTypeName;
	}

	public void setActivityTypeName(String activityTypeName) {
		this.activityTypeName = activityTypeName;
	}

	public String getActivityName() {
		return activityName;
	}

	public void setActivityName(String activityName) {
		this.activityName = activityName;
	}

	public String getProvince() {
		return province;
	}

	public void setProvince(String province) {
		this.province = province;
	}

	public String getCity() {
		return city;
	}

	public void setCity(String city) {
		this.city = city;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ActivityDataMid other = (ActivityDataMid) obj;
		if (activityUuid == null) {
			if (other.activityUuid != null)
				return false;
		} else if (!activityUuid.equals(other.activityUuid))
			return false;
		if (city == null) {
			if (other.city != null)
				return false;
		} else if (!city.equals(other.city))
			return false;
		if (province == null) {
			if (other.province != null)
				return false;
		} else if (!province.equals(other.province))
			return false;
		if (theDValue == null) {
			if (other.theDValue != null)
				return false;
		} else if (!theDValue.equals(other.theDValue))
			return false;
		return true;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((activityUuid == null) ? 0 : activityUuid.hashCode());
		result = prime * result + ((city == null) ? 0 : city.hashCode());
		result = prime * result + ((province == null) ? 0 : province.hashCode());
		result = prime * result + ((theDValue == null) ? 0 : theDValue.hashCode());
		return result;
	}

}
