package com.platomix.activity.clickhouse.model;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;

import cn.hutool.core.lang.Dict;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 
 * Desc:渠道 
 * <p>
 * Modify:
 * <p>
 * Author: William Lynn
 * <p>
 * Create Date：Aug 18, 2021 5:49:37 PM
 *
 */
@Data
@TableName("DIC_BLADE_ACTIVITY_CHANNEL")
public class BladeActivityChannel implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
	@ApiModelProperty(value = "主键ID")
    private Long id;

    @TableField(value="activity_id")
	@ApiModelProperty(value = "活动ID")
    private Long activityId;

    @TableField(value="name")
	@ApiModelProperty(value = "渠道名称")
    private String name;

	@TableField(value="channel_id")
	@ApiModelProperty(value = "渠道ID")
    private String channelId;

	@TableField(value="cost_price")
	@ApiModelProperty(value = "渠道成本")
    private BigDecimal costPrice;

	@TableField(value="channel_type")
	@ApiModelProperty(value = "渠道类型")
    private String channelType;

	@TableField(value="product_id")
	@ApiModelProperty(value = "涉及产品")
    private Long productId;

	@TableField(value="order_id")
	@ApiModelProperty(value = "订购渠道ID")
    private String orderId;

	@TableField(value="channel_long_link")
	@ApiModelProperty(value = "渠道长链接")
    private String channelLongLink;

	@TableField(value="channel_short_link")
	@ApiModelProperty(value = "渠道短链接")
    private String channelShortLink;

	@TableField(value="apply_for_time")
	@ApiModelProperty(value = "申请时间")
	@JsonFormat(pattern = "yyyy-MM-dd")
    private Date applyForTime;

	@TableField(value="online_time")
	@ApiModelProperty(value = "上线时间")
	@JsonFormat(pattern = "yyyy-MM-dd")
    private Date onlineTime;

	@TableField(value="remark")
	@ApiModelProperty(value = "备注")
    private String remark;

	@TableField(value="create_time")
	@ApiModelProperty(value = "创建时间")
	@JsonFormat(pattern = "yyyy-MM-dd")
    private Date createTime;

	@TableField(value="update_time")
	@ApiModelProperty(value = "修改时间")
	@JsonFormat(pattern = "yyyy-MM-dd")
    private Date updateTime;

	@TableField(value="status")
	@ApiModelProperty(value = "状态")
    private Integer status;

	public Dict toDict() {
		return Dict.create().set("channelId", channelId).set("orderId", orderId).set("channelName", name).set("channelType", channelType);
	}
}
