package com.platomix.activity.clickhouse.model;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 
 * Desc: 成本
 * <p>
 * Modify:
 * <p>
 * Author: William Lynn
 * <p>
 * Create Date：Aug 18, 2021 5:49:23 PM
 *
 */
@Data
@TableName("DIC_BLADE_ACTIVITY_COST")
public class BladeActivityCost implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
	@ApiModelProperty(value = "主键ID")
    private Long id;

    @TableField(value="activity_id")
	@ApiModelProperty(value = "活动ID")
    private Long activityId;

    @TableField(value="cost_name")
	@ApiModelProperty(value = "成本名称")
    private String costName;

    @TableField(value="cost_type")
	@ApiModelProperty(value = "成本类型")
    private Long costType;

    @TableField(value="cost_pice")
	@ApiModelProperty(value = "成本金额")
    private BigDecimal costPrice;

    @TableField(value="create_time")
	@ApiModelProperty(value = "创建时间")
	@JsonFormat(pattern = "yyyy-MM-dd")
	private Date createTime;

    @TableField(value="update_time")
	@ApiModelProperty(value = "修改时间")
	@JsonFormat(pattern = "yyyy-MM-dd")
	private Date updateTime;

    @TableField(value="status")
	@ApiModelProperty(value = "状态")
	private Integer status;


}
