package com.platomix.activity.clickhouse.model;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;

import cn.hutool.core.lang.Dict;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 
 * Desc: 奖品
 * <p>
 * Modify:
 * <p>
 * Author: William Lynn
 * <p>
 * Create Date：Aug 18, 2021 5:49:12 PM
 *
 */
@Data
@TableName("DIC_BLADE_ACTIVITY_PRIZE")
public class BladeActivityPrize implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
	@ApiModelProperty(value = "主键ID")
    private Long id;

    @TableField(value="activity_id")
	@ApiModelProperty(value = "活动ID")
    private Long activityId;

    @TableField(value="name")
	@ApiModelProperty(value = "奖品名称")
    private String name;

    @TableField(value="prize_type")
	@ApiModelProperty(value = "奖品类型")
    private Integer prizeType;

    @TableField(value="prize_id")
	@ApiModelProperty(value = "奖品ID")
    private String prizeId;

    @TableField(value="cost_price")
	@ApiModelProperty(value = "奖品单成本")
    private BigDecimal costPrice;

    @TableField(value="total_cost")
	@ApiModelProperty(value = "奖品总成本")
	private BigDecimal totalCost;

    @TableField(value="prize_level")
	@ApiModelProperty(value = "奖品等级")
	private Integer prizeLevel;

    @TableField(value="prize_count")
	@ApiModelProperty(value = "奖品数量")
	private Integer prizeCount;

    @TableField(value="used_count")
	@ApiModelProperty(value = "实际消耗总量")
	private Integer usedCount;

    @TableField(value="create_time")
	@ApiModelProperty(value = "创建时间")
	@JsonFormat(pattern = "yyyy-MM-dd")
	private Date createTime;

    @TableField(value="update_time")
	@ApiModelProperty(value = "修改时间")
	@JsonFormat(pattern = "yyyy-MM-dd")
	private Date updateTime;

    @TableField(value="status")
	@ApiModelProperty(value = "状态")
	private Integer status;

    public Dict toDict() {
		return Dict.create().set("prizeId", prizeId).set("prizeType", prizeType).set("prizeLevel", prizeLevel).set("prizeName", name);
	}
}
