package com.platomix.activity.clickhouse.model;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;

import cn.hutool.core.lang.Dict;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 
 * Desc:产品
 * <p>
 * Modify:
 * <p>
 * Author: William Lynn
 * <p>
 * Create Date：Aug 18, 2021 5:49:00 PM
 *
 */
@Data
@TableName("DIC_BLADE_ACTIVITY_PRODUCT")
public class BladeActivityProduct implements Serializable {

	private static final long serialVersionUID = 1L;

	@TableId(value = "id", type = IdType.AUTO)
	@ApiModelProperty(value = "主键ID")
	private Long id;

	@TableField(value = "activity_id")
	private Long activityId;

	@TableField(value = "name")
	private String name;

	@TableField(value = "spid")
	@ApiModelProperty(value = "spid")
	private String spid;

	@TableField(value = "cpid")
	private String cpid;

	@TableField(value = "large_type")
	private String largeType;

	@TableField(value = "small_type")
	private String smallType;

	@TableField(value = "cost_price")
	@ApiModelProperty(value = "单品成本价")
	private BigDecimal costPrice;

	@TableField(value = "total_cost")
	@ApiModelProperty(value = "产品总成本")
	private BigDecimal totalCost;

	@TableField(value = "formula_type")
	@ApiModelProperty(value = "总收入计算公式")
	private Integer formulaType;

	@TableField(value = "product_prices")
	@ApiModelProperty(value = "产品资费")
	private BigDecimal productPrices;

	@TableField(value = "unicom_divided")
	@ApiModelProperty(value = "联通分成")
	private BigDecimal unicomDivided;

	@TableField(value = "province_divided")
	@ApiModelProperty(value = "省份分成")
	private BigDecimal provinceDivided;

	@TableField(value = "create_time")
	@ApiModelProperty(value = "创建时间")
	@JsonFormat(pattern = "yyyy-MM-dd")
	private Date createTime;

	@TableField(value = "update_time")
	@ApiModelProperty(value = "修改时间")
	@JsonFormat(pattern = "yyyy-MM-dd")
	private Date updateTime;

	@TableField(value = "status")
	@ApiModelProperty(value = "状态")
	private Integer status;

	public Dict toDict() {
		return Dict.create().set("productName", name).set("spid", spid).set("cpid", cpid).set("largeType", largeType)
				.set("smallType", smallType);
	}

}
