package com.platomix.activity.clickhouse.model;

import java.io.Serializable;
import java.util.Date;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;

import cn.hutool.core.lang.Dict;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 
 * Desc:负责人
 * <p>
 * Modify:
 * <p>
 * Author: William Lynn
 * <p>
 * Create Date：Aug 18, 2021 5:48:33 PM
 *
 */
@Data
@TableName("DIC_BLADE_ACTIVITY_RESPONSIBLE")
public class BladeActivityResponsible implements Serializable {

	private static final long serialVersionUID = 1L;

	@TableId(value = "id", type = IdType.AUTO)
	@ApiModelProperty(value = "主键ID")
	private Long id;

	@TableField(value = "activity_id")
	@ApiModelProperty(value = "活动ID")
	private Long activityId;

	@TableField(value = "name")
	@ApiModelProperty(value = "负责人姓名")
	private String name;

	@TableField(value = "phone")
	@ApiModelProperty(value = "负责人电话")
	private String phone;

	@TableField(value = "email")
	@ApiModelProperty(value = "负责人邮箱")
	private String email;

	@TableField(value = "department")
	@ApiModelProperty(value = "负责人部门")
	private String department;

	@TableField(value = "position")
	@ApiModelProperty(value = "负责人职务")
	private String position;

	@TableField(value = "create_time")
	@ApiModelProperty(value = "创建时间")
	@JsonFormat(pattern = "yyyy-MM-dd")
	private Date createTime;

	@TableField(value = "update_time")
	@ApiModelProperty(value = "修改时间")
	@JsonFormat(pattern = "yyyy-MM-dd")
	private Date updateTime;

	public Dict toDict() {
		return Dict.create().set("managerName", name).set("managerPhone", phone).set("managerEmail", email)
				.set("managerDepartment", department).set("managerPosition", position);
	}
}
