package com.platomix.activity.clickhouse.model;

import java.io.Serializable;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;

import cn.hutool.core.lang.Dict;
import lombok.Data;

/**
 * Desc:
 * <p>
 * Modify:
 * <p>
 * Author: William Lynn
 * <p>
 * Create Date：Oct 13, 2021 3:31:32 PM
 * 
 */
@Data
@TableName("ETL_VW_TB_CALLER_AREACODE")
public class CallerAreaCode implements Serializable {

	private static final long serialVersionUID = 1L;

	@TableField(value = "CALLERHEAD")
	private String callerHead;

	@TableField(value = "PROVINCE")
	private String province;

	@TableField(value = "AREA")
	private String area;

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		CallerAreaCode other = (CallerAreaCode) obj;
		if (area == null) {
			if (other.area != null)
				return false;
		} else if (!area.equals(other.area))
			return false;
		if (province == null) {
			if (other.province != null)
				return false;
		} else if (!province.equals(other.province))
			return false;
		return true;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((area == null) ? 0 : area.hashCode());
		result = prime * result + ((province == null) ? 0 : province.hashCode());
		return result;
	}
	
	public Dict toDict() {
		return Dict.create().set("province", province).set("city", area);
	}
}
