package com.platomix.activity.clickhouse.service;

import java.time.LocalDateTime;

import org.springframework.stereotype.Service;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.platomix.activity.clickhouse.mapper.ActivityDataBaseInfoMapper;
import com.platomix.activity.clickhouse.model.ActivityDataBaseInfo;

import cn.hutool.core.date.LocalDateTimeUtil;

/**
 * Desc:
 * <p>
 * Modify:
 * <p>
 * Author: William Lynn
 * <p>
 * Create Date：Aug 18, 2021 4:23:35 PM
 * 
 */
@DS("clickhouse")
@Service
public class ActivityDataBaseInfoService extends ServiceImpl<ActivityDataBaseInfoMapper, ActivityDataBaseInfo> {

	public LocalDateTime getOldestActivityStartTime() {
		LambdaQueryWrapper<ActivityDataBaseInfo> queryWrapper = Wrappers.<ActivityDataBaseInfo>query().lambda()
				.orderByAsc(ActivityDataBaseInfo::getStartTime).last("LIMIT 0,1");
		ActivityDataBaseInfo data = baseMapper.selectOne(queryWrapper);
		LocalDateTime date = data != null ? LocalDateTimeUtil.of(data.getStartTime()) : null;
		return date;
	}

//	/**
//	 * 获取指定时间前开始的活动列表
//	 * 
//	 * @param date   截止日期
//	 * @param lastId 上次分页查询的最大主键
//	 * @param LIMIT  分页查询的数量
//	 * @return
//	 */
//	public List<ActivityDataBaseInfo> getActivityList(String date, long lastId, int limit) {
//		LambdaQueryWrapper<ActivityDataBaseInfo> queryWrapper = Wrappers.<ActivityDataBaseInfo>lambdaQuery()
//				.lt(ActivityDataBaseInfo::getStartTime, date).isNotNull(ActivityDataBaseInfo::getActivityUuid)
//				.gt(ActivityDataBaseInfo::getId, lastId).orderByAsc(ActivityDataBaseInfo::getId)
//				.last("LIMIT 0," + limit);
//		return baseMapper.selectList(queryWrapper);
//	}
}
