package com.platomix.activity.clickhouse.service;

import java.util.List;

import org.springframework.stereotype.Service;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.platomix.activity.clickhouse.mapper.BladeActivityChannelMapper;
import com.platomix.activity.clickhouse.model.BladeActivityChannel;

/**
 * Desc: 渠道
 * <p>
 * Modify:
 * <p>
 * Author: William Lynn
 * <p>
 * Create Date：Aug 18, 2021 4:23:35 PM
 * 
 */
@DS("clickhouse")
@Service
public class BladeActivityChannelService extends ServiceImpl<BladeActivityChannelMapper, BladeActivityChannel> {

	/*
	 * 根据活动ID获取渠道
	 */
	public List<BladeActivityChannel> get(Long activityId) {
		LambdaQueryWrapper<BladeActivityChannel> queryWrapper = Wrappers.<BladeActivityChannel>lambdaQuery()
				.eq(BladeActivityChannel::getActivityId, activityId);
		return baseMapper.selectList(queryWrapper);
	}

}
