package com.platomix.activity.clickhouse.service;

import java.util.List;

import org.springframework.stereotype.Service;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.platomix.activity.clickhouse.mapper.BladeActivityPrizeMapper;
import com.platomix.activity.clickhouse.model.BladeActivityPrize;

/**
 * Desc: 奖品
 * <p>
 * Modify:
 * <p>
 * Author: William Lynn
 * <p>
 * Create Date：Aug 18, 2021 4:23:35 PM
 * 
 */
@DS("clickhouse")
@Service
public class BladeActivityPrizeService extends ServiceImpl<BladeActivityPrizeMapper, BladeActivityPrize> {

	/*
	 * 获取活动关联的奖品
	 */
	public List<BladeActivityPrize> get(Long activityId) {
		LambdaQueryWrapper<BladeActivityPrize> queryWrapper = Wrappers.<BladeActivityPrize>lambdaQuery()
				.eq(BladeActivityPrize::getActivityId, activityId);
		return baseMapper.selectList(queryWrapper);
	}

}
