package com.platomix.activity.clickhouse.service;

import java.util.List;

import org.springframework.stereotype.Service;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.platomix.activity.clickhouse.mapper.BladeActivityProductMapper;
import com.platomix.activity.clickhouse.model.BladeActivityProduct;

/**
 * Desc: 产品
 * <p>
 * Modify:
 * <p>
 * Author: William Lynn
 * <p>
 * Create Date：Aug 18, 2021 4:23:35 PM
 * 
 */
@DS("clickhouse")
@Service
public class BladeActivityProductService extends ServiceImpl<BladeActivityProductMapper, BladeActivityProduct> {

	/*
	 * 获取活动关联的产品
	 */
	public List<BladeActivityProduct> get(Long activityId) {
		LambdaQueryWrapper<BladeActivityProduct> queryWrapper = Wrappers.<BladeActivityProduct>lambdaQuery()
				.eq(BladeActivityProduct::getActivityId, activityId);
		return baseMapper.selectList(queryWrapper);
	}

}
