package com.platomix.activity.clickhouse.service;

import java.util.List;

import org.springframework.stereotype.Service;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.platomix.activity.clickhouse.mapper.BladeActivityResponsibleMapper;
import com.platomix.activity.clickhouse.model.BladeActivityResponsible;

/**
 * Desc: 负责人
 * <p>
 * Modify:
 * <p>
 * Author: William Lynn
 * <p>
 * Create Date：Aug 18, 2021 4:23:35 PM
 * 
 */
@DS("clickhouse")
@Service
public class BladeActivityResponsibleService extends ServiceImpl<BladeActivityResponsibleMapper, BladeActivityResponsible> {

	/*
	 * 获取活动负责人
	 */
	public List<BladeActivityResponsible> get(Long activityId) {
		LambdaQueryWrapper<BladeActivityResponsible> queryWrapper = Wrappers.<BladeActivityResponsible>lambdaQuery()
				.eq(BladeActivityResponsible::getActivityId, activityId);
		return baseMapper.selectList(queryWrapper);
	}

}
