package com.platomix.activity.common;

/**
 * 
 * Desc:请求响应实体类
 * <p>
 * Modify:
 * <p>
 * Author: William Lynn
 * <p>
 * Create Date：Aug 11, 2021 11:39:53 AM
 *
 */
public class Ret<T> extends BaseModel {
	private static final long serialVersionUID = 1L;

	public final static int SUCCESS = 200;
	public final static int FAILURE = 500;

	private int code;
	private String msg;
	private T data;

	public Ret() {
	}

	public Ret(int code, String msg, T data) {
		super();
		this.code = code;
		this.msg = msg;
		this.data = data;
	}

	public static <T> Ret<T> success(String message) {
		return Ret.success(message, null);
	}

	public static <T> Ret<T> success(T data) {
		return Ret.success("操作成功", data);
	}

	public static <T> Ret<T> success(String message, T data) {
		return new Ret<T>(SUCCESS, message, data);
	}

	public static <T> Ret<T> success() {
		return Ret.success("操作成功");
	}

	public static <T> Ret<T> error() {
		return Ret.error("操作失败");
	}

	public static <T> Ret<T> error(String message) {
		return Ret.error(message, null);
	}

	public static <T> Ret<T> error(String message, T data) {
		return new Ret<T>(FAILURE, message, data);
	}

	public static <T> Ret<T> finish(boolean ret) {
		return new Ret<T>(ret ? SUCCESS : FAILURE, ret ? "操作成功" : "操作失败", null);
	}

	public int getCode() {
		return code;
	}

	public void setCode(int code) {
		this.code = code;
	}

	public T getData() {
		return data;
	}

	public void setData(T data) {
		this.data = data;
	}

	public boolean isSuccess() {
		return code == SUCCESS;
	}

	public String getMsg() {
		return msg;
	}

	public void setMsg(String msg) {
		this.msg = msg;
	}

}
