package com.platomix.activity.enums;

import com.baomidou.mybatisplus.annotation.EnumValue;

/**
 * 
 * Desc: 活动类型
 * <p>
 * Modify:
 * <p>
 * Author: William Lynn
 * <p>
 * Create Date：Sep 3, 2021 6:39:30 PM
 *
 */
public enum ActivityTypeEnum {
	//1=活动类 2=订购类 3=游戏类 4=秒杀类 5=助力类 6=抽奖类
	activity(1, "活动类"),
	order(2, "订购类"),
	game(3, "游戏类"),
	seckill(4, "秒杀类"),
	assist(5, "助力类"),
	draw(6, "抽奖类");
	
	@EnumValue
	private Integer value;
	private String message;
	private ActivityTypeEnum(Integer value, String message) {
		this.value = value;
		this.message = message;
	}
	
	public Integer getValue() {
		return value;
	}

	public void setValue(Integer value) {
		this.value = value;
	}

	public String getMessage() {
		return message;
	}

	public void setMessage(String message) {
		this.message = message;
	}
	
	public static ActivityTypeEnum reslove(Integer value) {
		ActivityTypeEnum[] values = ActivityTypeEnum.values();
		for(ActivityTypeEnum val : values) {
			if(value != null && val.getValue().intValue() == value) {
				return val;
			}
		}
		return null;
	}

}
