package com.platomix.activity.enums;

import com.baomidou.mybatisplus.annotation.EnumValue;

/**
 * 
 * Desc: 活动状态(0=未发布 1=待审核 2=未开始 3=进行中 4=审核驳回 5=已结束)
 * <p>
 * Modify:
 * <p>
 * Author: William Lynn
 * <p>
 * Create Date：Sep 3, 2021 6:39:30 PM
 *
 */
public enum StatusEnum {
	//活动状态(0=未发布 1=待审核 2=未开始 3=进行中 4=审核驳回 5=已结束)
	unpublished(0, "未发布"),
	unchecked(1, "待审核"),
	not_started(2, "未开始"),
	in_progress(3, "进行中"),
	reject(4, "审核驳回"),
	finish(5, "已结束");
	
	@EnumValue
	private Integer value;
	private String message;
	private StatusEnum(Integer value, String message) {
		this.value = value;
		this.message = message;
	}
	
	public Integer getValue() {
		return value;
	}

	public void setValue(Integer value) {
		this.value = value;
	}

	public String getMessage() {
		return message;
	}

	public void setMessage(String message) {
		this.message = message;
	}
	
	public static StatusEnum reslove(Integer value) {
		StatusEnum[] values = StatusEnum.values();
		for(StatusEnum val : values) {
			if(value != null && val.getValue().intValue() == value) {
				return val;
			}
		}
		return null;
	}

}
