package com.platomix.activity.enums;

import com.baomidou.mybatisplus.annotation.EnumValue;

/**
 * 
 * Desc: 0 平台活动录入 1 第三方活动录入
 * <p>
 * Modify:
 * <p>
 * Author: William Lynn
 * <p>
 * Create Date：Sep 3, 2021 6:39:30 PM
 *
 */
public enum ThirdEnum {
	//活动状态(0=未发布 1=待审核 2=未开始 3=进行中 4=审核驳回 5=已结束)
	self(0, "自有平台"),
	third(1, "第三方平台");
	
	@EnumValue
	private Integer value;
	private String message;
	private ThirdEnum(Integer value, String message) {
		this.value = value;
		this.message = message;
	}
	
	public Integer getValue() {
		return value;
	}

	public void setValue(Integer value) {
		this.value = value;
	}

	public String getMessage() {
		return message;
	}

	public void setMessage(String message) {
		this.message = message;
	}
	
	public static ThirdEnum reslove(Integer value) {
		ThirdEnum[] values = ThirdEnum.values();
		for(ThirdEnum val : values) {
			if(value != null && val.getValue().intValue() == value) {
				return val;
			}
		}
		return null;
	}

}
