package com.platomix.activity.kit;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;

/**
 * Desc: 表结构生成Model
 * <p>
 * Modify:
 * <p>
 * Author: William Lynn
 * <p>
 * Create Date：Aug 10, 2021 4:55:32 PM
 * 
 */
public class Generator {

	private PreparedStatement ps = null;
	private ResultSet rs = null;
	private static Connection con = null;
	private CallableStatement cst = null;

	static class Ora {
		static final String DRIVER_CLASS = "oracle.jdbc.driver.OracleDriver";
		static final String DATABASE_URL = "jdbc:oracle:thin:@10.0.17.143:1521:yy17143";
		static final String DATABASE_USER = "YYOS2";
		static final String DATABASE_PASSWORD = "R68PNA-4LRTWl~BmGwh";
	}

	static class MySql {
		static final String DRIVER_CLASS = "com.mysql.jdbc.Driver";
		static final String DATABASE_URL = "jdbc:mysql://localhost/plusoft_test?useUnicode=true&characterEncoding=GBK";
		static final String DATABASE_USER = "root";
		static final String DATABASE_PASSWORD = "1234";
	}
	
	static class Click {
		static final String DRIVER_CLASS = "ru.yandex.clickhouse.ClickHouseDriver";
		static final String DATABASE_URL = "jdbc:clickhouse://10.0.17.143:8123/ads";
		static final String DATABASE_USER = "default";
		static final String DATABASE_PASSWORD = "ltbiydhao66";
	}
	
	public static Connection getClickConnection() {
		try {
			Class.forName(Click.DRIVER_CLASS);
			con = DriverManager.getConnection(Click.DATABASE_URL, Click.DATABASE_USER, Click.DATABASE_PASSWORD);
			return con;
		} catch (Exception ex) {
			System.out.println(ex.getMessage());
		}
		return con;
	}

	public static Connection getOracleConnection() {
		try {
			Class.forName(Ora.DRIVER_CLASS);
			con = DriverManager.getConnection(Ora.DATABASE_URL, Ora.DATABASE_USER, Ora.DATABASE_PASSWORD);
			return con;
		} catch (Exception ex) {
			System.out.println(ex.getMessage());
		}
		return con;
	}

	public static Connection getMySqlConnection() {
		try {
			Class.forName(MySql.DRIVER_CLASS);
			con = DriverManager.getConnection(MySql.DATABASE_URL, MySql.DATABASE_USER, MySql.DATABASE_PASSWORD);
			return con;
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		return con;
	}

	public static List<Map> getOracleTable(String Table) throws SQLException {
		getOracleConnection();
		List<Map> list = new ArrayList<Map>();
		try {
			DatabaseMetaData m_DBMetaData = con.getMetaData();
			// getColumns(java.lang.String catalog, java.lang.String schema,java.lang.String
			// table, java.lang.String col)
			ResultSet colrs = m_DBMetaData.getColumns(null, Ora.DATABASE_USER.toUpperCase(), Table.toUpperCase(), "%");
			while (colrs.next()) {
				Map map = new HashMap();
				String columnName = colrs.getString("COLUMN_NAME");
				String columnType = colrs.getString("TYPE_NAME");
				int datasize = colrs.getInt("COLUMN_SIZE");
				int digits = colrs.getInt("DECIMAL_DIGITS");
				int nullable = colrs.getInt("NULLABLE");
				String remarks = colrs.getString("REMARKS");
				map.put("columnName", columnName);
				map.put("columnType", columnType);
				map.put("datasize", datasize);
				map.put("remarks", remarks);
				list.add(map);
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			con.close();
		}
		return list;
	}

	/**
	 * 把Oracle字段类型 转化为 java类型
	 * 
	 * @param sqlType 字段类型
	 * @param size    字段大小
	 * @param scale   默认=0
	 * @return
	 */
	public static String oracleSqlType2JavaType(String sqlType, int size, int scale) {
		if (sqlType.equals("integer")) {
			return "Integer";
		} else if (sqlType.equals("long")) {
			return "Long";
		} else if (sqlType.equals("float") || sqlType.equals("float precision") || sqlType.equals("double")
				|| sqlType.equals("double precision")) {
			return "BigDecimal";
		} else if (sqlType.equals("number") || sqlType.equals("decimal") || sqlType.equals("numeric")
				|| sqlType.equals("real")) {
			return scale == 0 ? (size < 10 ? "Integer" : "Long") : "BigDecimal";
		} else if (sqlType.equals("varchar") || sqlType.equals("varchar2") || sqlType.equals("char")
				|| sqlType.equals("nvarchar") || sqlType.equals("nchar")) {
			return "String";
		} else if (sqlType.equals("datetime") || sqlType.equals("date") || sqlType.equals("timestamp")) {
			return "Date";
		}
		return "String";
	}

	public static String getItems(List<Map> map, String tablename) {
		// 记得转化成小写
		StringBuffer sb = new StringBuffer();
		sb.append("package com.platomix.activity.oracle.model;\n");
		sb.append("\r\n");
		sb.append("import java.util.Date;\r\n");
		sb.append("import com.baomidou.mybatisplus.annotation.TableField;\r\n");
		sb.append("import com.baomidou.mybatisplus.annotation.TableName;\r\n");
		sb.append("import lombok.Data;\r\n");
		sb.append("\r\n");
		sb.append("/** \r\n " + " *  \r\n" + " * @author William Lin  \r\n" + " *\r\n" + "*/\r\n");
		sb.append("\r\n");
		sb.append("@TableName(\""+tablename+"\")\n");
		sb.append("@Data\n");
		sb.append("public class " + getUpperOne(tablename.toLowerCase()) + "  implements java.io.Serializable  {\r\n");
		sb.append("\r\n");
		sb.append("private static final long serialVersionUID = 1L;\r\n");
		// 得到私有属性
		for (Map map0 : map) {
			String columnname = map0.get("columnName").toString();
			String columntype = map0.get("columnType").toString();
			String columnsize = map0.get("datasize").toString();
			String remarks = map0.get("remarks") == null ? "" : map0.get("remarks").toString();
			String javaType = oracleSqlType2JavaType(columntype.toLowerCase(), Integer.parseInt(columnsize), 0);
			
			String temp = "@TableField(value=\""+columnname+"\")";
			temp += "\nprivate " + javaType + " " + columnname.toLowerCase() + "; //" + remarks + "\r\n";
			sb.append("\r\n");
			sb.append(temp);
		}
		// 得到getter和setter
//		for (Map map0 : map) {
//			String columnname = map0.get("columnName").toString();
//			String columntype = map0.get("columnType").toString();
//			String columnsize = map0.get("datasize").toString();
//			String javaType = oracleSqlType2JavaType(columntype.toLowerCase(), Integer.parseInt(columnsize), 0);
//			String temp = "\tpublic " + javaType + " " + "get" + getUpperOne(columnname.toLowerCase()) + "(){\r\n";
//			String temp1 = "\t\treturn " + columnname.toLowerCase() + ";\r\n";
//			String temp2 = "\t}\r\n";
//			sb.append(temp + temp1 + temp2);
//			temp = "\tpublic void " + "set" + getUpperOne(columnname.toLowerCase()) + "(" + javaType + " "
//					+ columnname.toLowerCase() + "){\r\n";
//			temp1 = "\t\tthis." + columnname.toLowerCase() + " = " + columnname.toLowerCase() + ";\r\n";
//			temp2 = "\t}\r\n";
//			sb.append(temp + temp1 + temp2);
//		}
		sb.append("}");
		return sb.toString();

	}

	/**
	 * 把输入字符串的首字母改成大写
	 * 
	 * @param str
	 * @return
	 */
	public static String getUpperOne(String str) {
		char[] ch = str.toCharArray();
		if (ch[0] >= 'a' && ch[0] <= 'z') {
			ch[0] = (char) (ch[0] - 32);
		}
		return new String(ch);
	}

	public static void main(String[] args) throws IOException {

		try {
			String tables = "FCT_CS_RECORDS,HIS_FLOW_ORDER_201901";
			String[] arr = tables.split(",");
			for (String string : arr) {
				String name = getUpperOne(string.toLowerCase());
				List<Map> map = getOracleTable(string);
				String a = getItems(map, string);
				File file = new File(
						"/Users/Kevin/Documents/workspace/javaweb/activity-analysis/activity-analysis-biz/src/main/java/com/platomix/activity/oracle/model/" + name
								+ ".java");
				if (!file.exists()) {
					file.createNewFile();
				}
				FileOutputStream fos = new FileOutputStream(file, true);// true表示在文件末尾追加
				fos.write(a.getBytes());
				fos.close();// 流要及时关闭
			}
			System.out.println("生成java完成");
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

}
