CREATE TABLE ads.ACTIVITY_DATA_BASE_INFO
(

    `ID` UInt64 COMMENT '序号',

    `ACTIVITY_ID` UInt64 COMMENT 'blade_activity主键',

    `ACTIVITY_UUID` String COMMENT '活动UUID',

    `ACTIVITY_NAME` String COMMENT '活动名称',

    `ACTIVITY_TYPE` Int32 COMMENT '活动类型值，1=活动类 2=订购类 3=游戏类 4=秒杀类 5=助力类 6=抽奖类',

    `ACTIVITY_TYPE_NAME` Nullable(String) COMMENT '活动类型名称',

    `START_TIME` DateTime COMMENT '开始时间',

    `END_TIME` DateTime COMMENT '结束时间',

    `CASH_DEADLINE` DateTime COMMENT '兑奖截止时间',

    `DEADLINE` DateTime COMMENT '维度截止时间',

    `STATUS` Int32 COMMENT '活动状态值(0=未发布 1=待审核 2=未开始 3=进行中 4=审核驳回 5=已结束)',

    `STATUS_NAME` Nullable(String) COMMENT '活动状态',

    `IS_THIRD` Int32 COMMENT '0 平台活动录入 1 第三方活动录入',

    `IS_THIRD_NAME` Nullable(String) COMMENT '0 平台活动录入 1 第三方活动录入',
    
    `SPIDS` Array(String) COMMENT '关联的产品ID',

    `COST_TOTAL_ACTIVITY` Nullable(Decimal(18,2)) COMMENT '活动总成本',

    `COST_TOTAL_PRIZE` Nullable(Decimal(18,2)) COMMENT '奖品总成本',

    `COST_TOTAL_CHANNEL` Nullable(Decimal(18,2)) COMMENT '渠道总成本',

    `COST_TOTAL_PRODUCT` Nullable(Decimal(18,2)) COMMENT '产品总成本',

    `COST_TOTAL_OTHER` Nullable(Decimal(18,2)) COMMENT '其它总成本',

    `CREATE_TIME` DateTime COMMENT '创建时间'
)
ENGINE = MergeTree
ORDER BY ID
SETTINGS index_granularity = 8192
