CREATE TABLE ads.ACTIVITY_DATA_MID_EXCHANGE
(
	`PARTITION_KEY` Int32 COMMENT '分区键（按月分区）',
	
    `THEDVALUE` Int32 COMMENT '时间维度值（月示例：202101，天示例：20210101，小时示例：2021010101）',

    `ACTIVITY_NAME` String COMMENT '活动名称',

    `ACTIVITY_UUID` String COMMENT '活动UUID',

    `ACTIVITY_TYPE` Int32 COMMENT '活动类型值，1=活动类 2=订购类 3=游戏类 4=秒杀类 5=助力类 6=抽奖类',

    `ACTIVITY_TYPE_NAME` Nullable(String) COMMENT '活动类型名称',

    `PROVINCE` Nullable(String) COMMENT '省份',

    `CITY` Nullable(String) COMMENT '城市',

    `CASH_PRIZE_MAN_TIMES` Nullable(Int64) COMMENT '兑奖人次',

    `CASH_PRIZE_USERS_NEW` Nullable(Int64) COMMENT '新用户兑奖人数',

    `CASH_PRIZE_USERS_OLD` Nullable(Int64) COMMENT '老用户兑奖人数',

    `CASH_PRIZE_USERS_VALID` Nullable(Int64) COMMENT '有效用户兑奖人数',

    `CASH_PRIZE_RATE` Nullable(Decimal(9,4)) COMMENT '兑奖率'
)
ENGINE = MergeTree
ORDER BY THEDVALUE
SETTINGS index_granularity = 8192

