CREATE TABLE ads.ACTIVITY_DATA_MID_JOIN
(
	`PARTITION_KEY` Int32 COMMENT '分区键（按月分区）',
	
    `THEDVALUE` Int32 COMMENT '时间维度值（月示例：202101，天示例：20210101，小时示例：2021010101）',

    `ACTIVITY_UUID` String COMMENT '活动UUID',

    `ACTIVITY_TYPE` Int32 COMMENT '活动类型值，1=活动类 2=订购类 3=游戏类 4=秒杀类 5=助力类 6=抽奖类',

    `ACTIVITY_TYPE_NAME` Nullable(String) COMMENT '活动类型名称',

    `ACTIVITY_NAME` String COMMENT '活动名称',

    `PROVINCE` Nullable(String) COMMENT '省份',

    `CITY` Nullable(String) COMMENT '城市',

    `CHANNEL_ID` String COMMENT '推广渠道ID',

    `CHANNEL_NAME` String COMMENT '渠道名称',
    
    `JOIN_USERS` Nullable(Int64) COMMENT '参与人数',

    `JOIN_USERS_NEW` Nullable(Int64) COMMENT '新用户参与人数',

    `JOIN_USERS_OLD` Nullable(Int64) COMMENT '老用户参与人数',

    `JOIN_USERS_VALID` Nullable(Int64) COMMENT '有效用户参与人数',

    `WIN_MAN_TIMES` Nullable(Int64) COMMENT '中奖人次',

    `WIN_USERS` Nullable(Int64) COMMENT '中奖人数',

    `ORDER_USERS_NEW` Nullable(Int64) COMMENT '新用户订购数',

    `ORDER_USERS_OLD` Nullable(Int64) COMMENT '老用户订购数',

    `ORDER_USERS_VALID` Nullable(Int64) COMMENT '有效用户订购数',
    
    `ORDER_USERS_BY_ACTIVITY` Nullable(Int64) COMMENT '新增订购用户数',
    
    `ORDER_USERS_CANCEL_ACTIVITY` Nullable(Int64) COMMENT '退订用户数',
    
    `ORDER_USERS_NET_GROWTH_ACTIVITY` Nullable(Int64) COMMENT '净增用户数',

    `CONVERSION_RATE` Nullable(Decimal(9,4)) COMMENT '活动转化率'
)
ENGINE = MergeTree
ORDER BY THEDVALUE
SETTINGS index_granularity = 8192

