CREATE TABLE ads.ACTIVITY_DATA_RECORD_EXCHANGE
(
    `PARTITION_KEY` Int32 COMMENT '分区键（按月分区）',

    `EXCHANGE_ID` UInt64 COMMENT 'activity_member_exchange_record主键',

    `ACTIVITY_UUID` String COMMENT '活动UUID',

    `ACTIVITY_NAME` String COMMENT '活动名称',

    `ACTIVITY_TYPE` Int32 COMMENT '活动类型值，1=活动类 2=订购类 3=游戏类 4=秒杀类 5=助力类 6=抽奖类',

    `ACTIVITY_TYPE_NAME` Nullable(String) COMMENT '活动类型名称',

    `PRIZE_ID` String COMMENT '奖品ID',

    `PRIZE_NAME` Nullable(String) COMMENT '奖品名称',

    `PRIZE_TYPE` Nullable(Int32) COMMENT '奖品类型',

    `PRIZE_LEVEL` Nullable(Int32) COMMENT '奖品等级',

    `WIN_CODE`  Nullable(String) COMMENT '兑奖码',

    `PROVINCE` String COMMENT '兑奖者省份',

    `CITY` String COMMENT '兑奖者城市',

    `PHONE` String COMMENT '兑奖者手机号',

    `EXCHANGE_TIME` DateTime COMMENT '兑奖时间',

    `EXCHANGE_STATUS` Int32 COMMENT '1 已兑奖 2 未兑奖',

    `EXCHANGE_STATUS_NAME` Nullable(String) COMMENT '1 已兑奖 2 未兑奖',

    `DATE_VALUE_MONTH` Int32 COMMENT '月维度值（月示例：202101）',

    `DATE_VALUE_DAY` Int32 COMMENT '天维度值（天示例：20210101）',

    `DATE_VALUE_HOUR` Int32 COMMENT '时维度值（小时示例：2021010101）',
    
    `IS_ORDER_YEAR` Int32 COMMENT '活动开始前12个月是否有订购关系',
    
    `IS_ORDER_IN_ACTIVITY` Int32 COMMENT '活动期内是否有订购关系',

    `CREATE_TIME` DateTime default now() COMMENT '创建时间'
)
ENGINE = MergeTree
ORDER BY EXCHANGE_ID
SETTINGS index_granularity = 8192

