CREATE TABLE ads.ACTIVITY_DATA_RECORD_JOIN
(
	`PARTITION_KEY` Int32 COMMENT '分区键（按月分区）',
	
    `JOIN_ID` UInt64 COMMENT 'activity_participate_record主键',

    `ACTIVITY_UUID` String COMMENT '活动UUID',

    `ACTIVITY_NAME` String COMMENT '活动名称',

    `ACTIVITY_TYPE` Int32 COMMENT '活动类型值，1=活动类 2=订购类 3=游戏类 4=秒杀类 5=助力类 6=抽奖类',

    `ACTIVITY_TYPE_NAME` Nullable(String) COMMENT '活动类型名称',

    `CHANNEL_ID` String COMMENT '推广渠道ID',

    `CHANNEL_NAME` String COMMENT '渠道名称',
    
    `CHANNEL_ID_ORDER` Nullable(String) COMMENT '订购渠道ID',

    `CHANNEL_TYPE` Nullable(String) COMMENT '渠道类型 1=客户端 2=省分 3=手厅 4=自有 0=其它',

    `PROVINCE` String COMMENT '参与者省份',

    `CITY` String COMMENT '参与者城市',

    `PHONE` String COMMENT '参与者手机号',

    `IP` Nullable(String) COMMENT '参与者IP',

    `IS_HIT` Int32 COMMENT '是否中奖',

    `JOIN_TIME` DateTime COMMENT '参与时间',

    `DATE_VALUE_MONTH` Int32 COMMENT '月维度值（月示例：202101）',

    `DATE_VALUE_DAY` Int32 COMMENT '天维度值（天示例：20210101）',

    `DATE_VALUE_HOUR` Int32 COMMENT '时维度值（小时示例：2021010101）',
    
    `IS_ORDER_YEAR` Int32 COMMENT '活动开始前12个月是否有订购关系',
    
    `IS_ORDER_IN_ACTIVITY` Int32 COMMENT '活动期内是否有订购关系',
    
    `IS_ORDER_BY_ACTIVITY` Int32 COMMENT '是否订通过活动购过',

    `CREATE_TIME` DateTime default now() COMMENT '创建时间'
)
ENGINE = MergeTree
ORDER BY JOIN_ID
SETTINGS index_granularity = 8192