package com.platomix.activity.job;

import org.springframework.beans.factory.annotation.Autowired;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.platomix.activity.clickhouse.model.CallerAreaCode;
import com.platomix.activity.clickhouse.service.CallerAreaCodeService;
import com.platomix.activity.kit.TimeKit;

import cn.hutool.core.util.StrUtil;
import lombok.extern.slf4j.Slf4j;

/**
 * Desc:
 * <p>
 * Modify:
 * <p>
 * Author: William Lynn
 * <p>
 * Create Date：Oct 18, 2021 3:49:58 PM
 * 
 */
@Slf4j
public class AbsTask {

	@Autowired
	TimeKit timeKit;

	@Autowired
	private CallerAreaCodeService areaService;

	final int BATCH_SIZE = 1000;
	final int LIMIT = 1000;
	final int THREAD_NUM = 1;

	/**
	 * 根据手机号查询省市
	 * 
	 * @param phone
	 * @return {@link CallerAreaCode}
	 */
	protected CallerAreaCode getArea(String phone) {
		if (StrUtil.isBlankIfStr(phone)) {
			return null;
		}

		try {
			LambdaQueryWrapper<CallerAreaCode> queryWrapper = Wrappers.<CallerAreaCode>query().lambda()
					.eq(CallerAreaCode::getCallerHead, phone.substring(0, 7));
			return areaService.getOne(queryWrapper);
		} catch (Exception e) {
			log.error("getArea:fail:error is : " + e.getMessage());
		}
		return null;
	}
}
